import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ComputeSanityCheck implements Runnable {
    Manager M;
    Quad QUAD;  
    int halt;
    int export;
    Output writer;
    double A;

    public ComputeSanityCheck() {
    }

    public ComputeSanityCheck(double a,Manager MM) {
	this.A=a;
	this.M=MM;
    }


    public void run() {	
       int a=M.C.CON_S.CHECK.mode;
       penroseTorusPlot();
    }


	public static double dec(double x) {
	    return(x-Math.floor(x+.5));
	}

	public static Complex torusMap(double A,int x,int y) {
	    Complex z=new Complex();
	    double d=2*A*x+2*y+(1-A)/2;
	    z.x=dec(d*(1+A)/4);
	    z.y=dec(d/2);
	    return(z);
	}





    public Complex toComplex(int[][] X,double AA) {
	double d=toDouble(X[0][0],X[0][1],AA);
	Complex z1=new Complex(d,X[1][0]);
        return(z1);
    }


    public double toDouble(int x,int y,double AA) {
	double aa=M.C.CON_G.AGC.getOffset();
       	return(2*AA*x+2*y+aa);
    }


    public int[][] firstReturn(int[][] X,double AA) {
	PinwheelMap RM=new PinwheelMap(AA);
            int[] temp3=new int[2];
	    Complex z1=toComplex(X,AA);
	    temp3=RM.doReturnIntegral(z1);
	    int[][] Y=new int[2][2];
	    Y[0][0]=X[0][0]+temp3[0];
	    Y[0][1]=X[0][1]+temp3[1];
	    Y[1][0]=temp3[2];
	    Y[1][1]=0;
	    return(Y);
    }






    public ArithmeticGraphLocal doLocal(int i,int j,double AA) {
	ArithmeticGraphLocal L=new ArithmeticGraphLocal();
	L.gp=new GeneralPath();
	int[][] X1=new int[2][2];
	int[][] X2=new int[2][2];
	X1[0][0]=i;
	X1[0][1]=j;
	Complex test=toComplex(X1,AA);

	L.x[0]=-11111;
	L.x[1]=-11111;
	L.x[2]=-11111;
	L.x[3]=-11111;

	if(test.x>0) {
	  X1[1][0]=1;
	  X1[1][1]=0;
          X2=firstReturn(X1,AA);
	  L.gp.moveTo(X1[0][0],X1[0][1]);
	  L.gp.lineTo(X2[0][0],X2[0][1]);

	  L.x[0]=X2[0][0]-X1[0][0];
	  L.x[1]=X2[0][1]-X1[0][1];

	  X1[1][0]=-1;
	  X1[1][1]=0;
	  X2=firstReturn(X1,AA);
	  L.gp.moveTo(X1[0][0],X1[0][1]);
	  L.gp.lineTo(X2[0][0],X2[0][1]);

          L.x[2]=X2[0][0]-X1[0][0];
	  L.x[3]=X2[0][1]-X1[0][1];

	}
	return(L);
    }





    public void penroseTorusPlot() {	

	PenroseStripMap EM=new PenroseStripMap();
	int LIM=(int)(Math.pow(2,M.C.CON_S.ITER.val/2));
	int DEP=(int)(Math.pow(2,M.C.CON_S.ITER.val/2));
	ArithmeticGraphLocal L;
	halt=1;
	int count=0;
	GeneralPath gp=new GeneralPath();
	int fail=0;
	for(int i=-LIM;i<=LIM;++i) {
	    for(int j=-DEP;j<=DEP;++j) {

	        L=doLocal(i,j,A);
		L.toType();

		if(L.match(M.C.CON_S.LT)==1) {
		    Complex u=torusMap(A,i,j);
		    M.RT.POINT[M.RT.point]=new Complex(u);
		    M.RT.POINTCOLOR[M.RT.point]=M.C.CS.C;
		    ++M.RT.point;
		}

	    }

             Integer JJ=new Integer(i);
	     M.C.PROGRESS=JJ.toString();
	     M.C.repaint();
	}

	halt=0;
	M.RT.repaint();

    }



    /**checking the first return map against the old method.  This
       is really a check of the Pinwheel Lemma*/

    public Complex doOldReturn(double A,Complex z) {
	Quad Q=new Quad();
	Q=Q.setQuad(A);
	int test=0;
	double y;
	Complex w=new Complex(z);
	while(test==0) {
	    w=ComputeTile.nextComplex(w,Q);
	    w=ComputeTile.nextComplex(w,Q);
	    y=Math.abs(w.y)-1;
	    if((w.x>0)&&(y*y<.01)) test=1;
	}
	return(w);
    }

    public int testReturn(double A,Complex z) {
	PinwheelMap PW=new PinwheelMap(A);
	Complex z1=PW.doReturn(z);
	Complex z2=doOldReturn(A,z);
	double d=Complex.dist(z1,z2);
	if(d<.00001) return(0);
	return(1);
    }



    public void checkPinwheel() {
	double xDens=Math.pow(2.0,M.C.CON_S.INT[1].val);
	double range=Math.pow(2.0,M.C.CON_S.INT[2].val);
	double A=0;
	int test2=0;
	int test=0;
        Complex z=new Complex();
	PinwheelMap RM=new PinwheelMap(0);
	int i=1;
	int j=1;
	halt=1;
	A=Math.sqrt(5.0)-2.0;

	while((halt==1)&&(test2==0)) {

	z=new Complex(.000001+range*i/xDens,1);
	test=testReturn(A,z);
	if(test==1) test2=1;

	z=new Complex(.000001+range*i/xDens,-1);
	test=testReturn(A,z);
	if(test==1) test2=1;

	++i;
	if(i==xDens) test2=1;
	}
	halt=0;
    }


    

}

